part of masamune.data;

/// Stores location data.
///
/// Please inherit and use it.
@immutable
abstract class GeoData {
  /// Latitude.
  double get latitude;

  /// Longitude.
  double get longitude;

  /// Location name.
  String get name;

  /// Hash of [GeoData].
  String get hash;

  /// All neighbors of [GeoData].
  List<String> get neighbors;

  /// Calculate the distance between two points.
  ///
  /// [data]: GeoData.
  double distance(GeoData data);

  /// Stores location data.
  ///
  /// Please inherit and use it.
  const GeoData();

  /// Returns a string representation of this object.
  @override
  String toString() {
    if (isNotEmpty(this.name)) return this.name;
    return "$latitude,$longitude";
  }
}
